#include <bits/stdc++.h>
using namespace std;

bool otazka(int a, int b, int c) {
    cout << 0 << " " << a << " " << b << " " << c << endl << flush;
    int ans;
    cin >> ans;
    return ans > 0;
}

vector<bool> priradeny;

void najdi_susedov(int vrchol, vector<int> okolie, vector<int> &susedia, vector< vector<int> > &komponenty) {
    susedia.clear();
    komponenty.clear();
    int P = okolie.size();
    int pocet_priradenych = 0;
    for (int x : okolie) {
        priradeny[x] = false;
        if (x == vrchol) { priradeny[x] = true; ++pocet_priradenych; }
    }
    while (pocet_priradenych < P) {
        int kandidat = -1;
        for (int n=0; n<P; ++n) {
            int curr = okolie[n];
            if (priradeny[curr]) continue;
            if (kandidat == -1) {
                kandidat = curr;
                continue;
            }
            if (otazka(kandidat,curr,vrchol)) kandidat = curr;
        }
        susedia.push_back(kandidat);
        priradeny[kandidat] = true;
        ++pocet_priradenych;
        // tu sa este da optimalizovat: ak uz mame tretieho suseda, 
        // vsetci nepriradeni su jeho komponent
        vector<int> komponent;
        for (int n=0; n<P; ++n) {
            int curr = okolie[n];
            if (priradeny[curr]) continue;
            if (otazka(vrchol,kandidat,curr)) {
                komponent.push_back(curr);
                priradeny[curr] = true;
                ++pocet_priradenych;
            }
        }
        komponenty.push_back(komponent);
    }
}

int main() {
    int K, L;
    cin >> K >> L;
    int N = (1 << (K+1)) - 1;
    
    priradeny.resize(N+1);
    vector<int> vsetci(N);
    iota( vsetci.begin(), vsetci.end(), 1 );
    
    vector<int> susedia;
    vector<vector<int> > komponenty;
    vector< vector<int> > odpovede(N+1);
    queue<int> korene;
    queue<vector<int> > podstromy;

    for (int n=1; n<=N; ++n) {
        najdi_susedov(n, vsetci, susedia, komponenty);
        if (susedia.size() == 2u) {
            odpovede[n] = susedia;
            for (int i=0; i<int(susedia.size()); ++i) {
                korene.push(susedia[i]);
                podstromy.push(komponenty[i]);
            }
            break;
        }
    }

    while (!korene.empty()) {
        int koren = korene.front(); korene.pop();
        vector<int> podstrom = podstromy.front(); podstromy.pop();
        najdi_susedov(koren, podstrom, susedia, komponenty);
        odpovede[koren] = susedia;
        for (int i=0; i<int(susedia.size()); ++i) {
            korene.push(susedia[i]);
            podstromy.push(komponenty[i]);
        }
    }
    cout << 1 << endl << flush;
    for (int n=1; n<=N; ++n) {
        cout << odpovede[n].size();
        for (int x : odpovede[n]) cout << " " << x;
        cout << endl << flush;
    }
}
