#include <bits/stdc++.h>
using namespace std;

void error(const string &message) { cerr << message << endl; exit(1); }

int root;
vector<int> parent;
vector< vector<int> > children;

void otazka(int a, int b, int c) {
    vector<int> cestaa = {a}, cestac = {c};
    int wa = a, wc = c;
    while (cestaa.back() != root) { wa=parent[wa]; cestaa.push_back(wa); }
    while (cestac.back() != root) { wc=parent[wc]; cestac.push_back(wc); }
    reverse( cestaa.begin(), cestaa.end() );
    reverse( cestac.begin(), cestac.end() );
    while (cestaa.size() < cestac.size()) cestaa.push_back(a);
    while (cestaa.size() > cestac.size()) cestac.push_back(c);
    while (true) {
        if (b == cestaa.back() || b == cestac.back()) { cout << 1 << endl << flush; return; }
        if (cestaa.back() == cestac.back()) break;
        cestaa.pop_back();
        cestac.pop_back();
    }
    cout << 0 << endl << flush;
}

bool stejna_pole(vector<int> A, vector<int> B) {
    sort( A.begin(), A.end() );
    sort( B.begin(), B.end() );
    return A == B;
}

int main(int argc, char **argv) {
    if (argc != 2) {
	fprintf(stderr, "Jako argument zadej jméno vstupního souboru.\n");
	return 1;
    }

    ifstream fin(argv[1]);
    if (fin.fail()) {
	fprintf(stderr, "Nedaří se otevřít soubor %s\n", argv[1]);
	return 1;
    }

    int K, L;
    fin >> K >> L;
    cout << K << " " << L << endl;

    int N = (1 << (K+1)) - 1;

    parent.resize(N+1, -1);
    children.resize(N+1);
    for (int n=1; n<=N; ++n) {
        fin >> parent[n];
        if (parent[n] != 0) children[parent[n]].push_back(n);
    }
    for (int n=1; n<=N; ++n) if (parent[n] == 0) root = n;

    int questions = 0;
    while (true) {
        int typ;
        if (!(cin >> typ)) error("Výstup skončil bez výpisu odpovědi");
        if (typ != 0 && typ != 1) error("Očekáváno číslo 0 nebo 1");
        if (typ == 1) break;
        ++questions;
        if (questions > L) error("Příliš mnoho otázek");
        int a, b, c;
        if (!(cin >> a >> b >> c)) error("Příliš málo čísel v otázce");
        if (a < 1 || a > N) error("Chybné číslo zaměstnance v otázce");
        if (b < 1 || b > N) error("Chybné číslo zaměstnance v otázce");
        if (c < 1 || c > N) error("Chybné číslo zaměstnance v otázce");
        otazka(a, b, c);
    }

    // Kontrola výstupu
    for (int n=1; n<=N; ++n) {
        int deg;
        if (!(cin >> deg)) error("Příliš málo řádků v popisu firmy");
        if (deg != int(children[n].size())) error("Chybný počet podřízených");
        vector<int> jeho;
        while (int(jeho.size()) != deg) {
            int x;
            if (!(cin >> x)) error("Příliš málo čísel v seznamu podřízených");
            jeho.push_back(x);
        }
        if (!stejna_pole(children[n],jeho)) error("Chybná čísla podřízených");
    }
    cerr << "ok po " << questions << " otázkách" << endl << flush;
}
